//package com.example.flutter_android_connection_api;
//
//import android.app.Activity;
//import android.app.AlarmManager;
//import android.app.Application;
//import android.app.KeyguardManager;
//import android.app.PendingIntent;
//import android.content.Context;
//import android.content.Intent;
//import android.os.Build;
//import android.os.Bundle;
//import android.view.WindowManager;
//import androidx.annotation.NonNull;
//import androidx.annotation.Nullable;
//import androidx.annotation.RequiresApi;
//
//import java.lang.reflect.Array;
//import java.text.ParseException;
//import java.text.SimpleDateFormat;
//import java.util.Calendar;
//
//import io.flutter.embedding.android.FlutterActivity;
//import io.flutter.embedding.engine.FlutterEngine;
//import io.flutter.embedding.engine.plugins.FlutterPlugin;
//import io.flutter.embedding.engine.plugins.activity.ActivityAware;
//import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
//import io.flutter.plugin.common.BinaryMessenger;
//import io.flutter.plugin.common.MethodCall;
//import io.flutter.plugin.common.MethodChannel;
//
///** FlutterAndroidConnectionApiPlugin */
//public class FlutterAndroidConnectionApiPlugin extends FlutterActivity implements FlutterPlugin, MethodChannel.MethodCallHandler, ActivityAware {
//  private MethodChannel channel;
//  private Context context;
//  private static final String channelName = "flutter_android_connection_api_channel";
//
//
//
//  private void setup(FlutterAndroidConnectionApiPlugin plugin, BinaryMessenger binaryMessenger) {
//    plugin.channel = new MethodChannel(binaryMessenger, channelName);
//    plugin.channel.setMethodCallHandler(plugin);
//  }
//
//
//  @Override
//  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
//    context=flutterPluginBinding.getApplicationContext();
//    setup(this, flutterPluginBinding.getBinaryMessenger());
//  }
//
//
//
//
//  @RequiresApi(api = Build.VERSION_CODES.KITKAT)
//  @Override
//  public void onMethodCall(@NonNull MethodCall call, @NonNull MethodChannel.Result result) {
//    System.out.println(call.method+" was called");
//    switch (call.method) {
//      case "getPlatformVersion":
//        result.success("Android " + Build.VERSION.RELEASE);
//        break;
//      case "ringNow": {
//        String id = call.argument("id");
//        startMainActivity(id);
//        result.success("Tried ringing");
//        break;
//      }
//      default:
//        result.notImplemented();
//        break;
//    }
//  }
//
//  @Override
//  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
//    channel.setMethodCallHandler(null);
//  }
//
//
//  private void startMainActivity(String id) {
//    System.out.println("started mainActivity");
//    Activity activity = (Activity) context;
//    startActivity(FlutterActivity.createDefaultIntent(activity).putExtra("id", id));
//  }
//
//  @RequiresApi(api = Build.VERSION_CODES.KITKAT)
//  private void setAlarm(String id, String time, boolean repeat){
//    PendingIntent alarmIntent;
//    String [] timeArray = time.split(":");
//    AlarmManager alarmMgr = (AlarmManager) context.getSystemService(Context.ALARM_SERVICE);
//
//    Intent intent = new Intent(context, AlarmReceiver.class);
//    intent.setAction("AlarmReceiver");
//    intent.addFlags(Intent.FLAG_INCLUDE_STOPPED_PACKAGES);
//    intent.addFlags(Intent.FLAG_RECEIVER_FOREGROUND);
//    intent.putExtra("id",id);
//
//    alarmIntent = PendingIntent.getBroadcast(context, 0, intent, PendingIntent.FLAG_UPDATE_CURRENT);
//
//    Calendar c = Calendar.getInstance();
//    c.set(Calendar.YEAR, Integer.parseInt(timeArray[0]));
//    c.set(Calendar.MONTH, Integer.parseInt(timeArray[1])-1);
//    c.set(Calendar.DAY_OF_MONTH, Integer.parseInt(timeArray[2]));
//    c.set(Calendar.HOUR_OF_DAY, Integer.parseInt(timeArray[3]));
//    c.set(Calendar.MINUTE, Integer.parseInt(timeArray[4]));
//    c.set(Calendar.SECOND, Integer.parseInt(timeArray[5]));
//
//    if(!repeat){
//      if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
//        alarmMgr.setExactAndAllowWhileIdle (AlarmManager.RTC, 1000, alarmIntent);
//        System.out.println("Set alarm");
//      }
//      else{
//        System.out.println("failed");
//      }
//    }
//    else{
//      System.out.println("repeat");
//    }
//
//
//  }
//
//  @Override
//  public void onAttachedToActivity(@NonNull ActivityPluginBinding binding) {
//    System.out.println("ACTIVITY");
//  }
//
//  @Override
//  public void onDetachedFromActivityForConfigChanges() {
//
//  }
//
//  @Override
//  public void onReattachedToActivityForConfigChanges(@NonNull ActivityPluginBinding binding) {
//
//  }
//
//  @Override
//  public void onDetachedFromActivity() {
//
//  }
//
//
//
//}






package com.example.flutter_android_connection_api;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.KeyguardManager;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Build;
import android.os.PowerManager;
import android.view.WindowManager;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import io.flutter.embedding.android.FlutterActivity;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;


/** FlutterAndroidConnectionApiPlugin */
public class FlutterAndroidConnectionApiPlugin extends FlutterActivity implements FlutterPlugin, MethodCallHandler, ActivityAware {
  private MethodChannel channel;
  private Context context;
  private static final String channelName = "flutter_android_connection_api_channel";



  private static void setup(FlutterAndroidConnectionApiPlugin plugin, BinaryMessenger binaryMessenger) {
    plugin.channel = new MethodChannel(binaryMessenger, channelName);
    plugin.channel.setMethodCallHandler(plugin);

    //plugin.synth = new Synth();
    //TODO plugin.synth.start();

  }
  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    setup(this, flutterPluginBinding.getBinaryMessenger());
    context=flutterPluginBinding.getApplicationContext();
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    } else if (call.method.equals("testChannelCall")) {
      result.success("Moin Franz");
      startMainActivity();
    } else {
      result.notImplemented();
    }
    System.out.println(call.method+"   was called");
  }
  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }



  private void startMainActivity() {
    Intent intent = FlutterAndroidConnectionApiPlugin.withNewEngine().initialRoute("/alarm").build(context);
    intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
    context.startActivity(intent);
  }

  @Override
  public void onAttachedToActivity(@NonNull ActivityPluginBinding binding) {
  }

  @Override
  public void onDetachedFromActivityForConfigChanges() {

  }

  @Override
  public void onReattachedToActivityForConfigChanges(@NonNull ActivityPluginBinding binding) {

  }

  @Override
  public void onDetachedFromActivity() {

  }
}
